#ifndef GROUP_HPP
#define GROUP_HPP


#include"object.hpp"
#include<vector>




class
Group: public Object
{
  std::vector<MemberIndex>  empty_indexes;

public:
  std::vector<Object*>  children;

  Group(ObjectUID  uid=0, const char16_t*  name=u"unnamed group");


  MemberIndex  insert(Object*  obj);

  void  eject(MemberIndex  i);

  void  update();

};




#endif




