#ifndef HUMAN_HPP
#define HUMAN_HPP


#include"place.hpp"
#include"shape_context.hpp"
#include"moving_context.hpp"




struct
Body: public Object
{
  Object*     eye;
  Object*     ear;
  Object*    nose;
  Object*   mouth;
  Object*  breast;
  Object*    hand;
  Object*   penis;
  Object*  vagina;
  Object*     hip;
  Object*     leg;

public:
  Body(): Object(OBJ_body){}

};


enum{
  MOT_stand,
  MOT_walk,
};


class
Human: public Object
{
protected:
  Place*         current_place;
  PlaceElement*  current      ;

public:
  Body  body;

  ShapeContext    shpctx;
  MovingContext   movctx;

  Human(ObjectUID  uid, const char16_t*  name, Place*  place=nullptr, int  x=0, int  y=0);


  void  reset(Place*  place, int  x, int  y);
  void  reset(               int  x, int  y);

  void  move();

  virtual void        stand(){}
          void  start_stand();

  void        walk();
  void  start_walk(Dir  dir);

  void  update();

  void  draw() const;

};


class
Player: public Human
{
public:
  Player(const char16_t*  name, Place*  place, int  x, int  y);

  void  stand();

  void  act();

};


class
NonPlayer: public Human
{
public:
  NonPlayer(const char16_t*  name, Place*  place, int  x, int  y);

  void  stand();

};




#endif




