#include"human.hpp"
#include"place.hpp"
#include"text_area.hpp"
#include"button.hpp"




Player::
Player(const char16_t*  name, Place*  place, int  x, int  y):
Human(0,name,place,x,y)
{
}




void
Player::
stand()
{
    if(!sys.streaming_flag)
    {
      return;
    }


    if(test(KEY_p))
    {
      act();
    }

  else
    if(test(KEY_up))
    {
      start_walk(DIR_back);
    }

  else
    if(test(KEY_down))
    {
      start_walk(DIR_front);
    }

  else
    if(test(KEY_left))
    {
      start_walk(DIR_left);
    }

  else
    if(test(KEY_right))
    {
      start_walk(DIR_right);
    }
}


void
Player::
act()
{
  PlaceElement*  pel = nullptr;

    switch(movctx.shape_dir)
    {
      case(DIR_left ): pel = current->left ;break;
      case(DIR_right): pel = current->right;break;
      case(DIR_back ): pel = current->up   ;break;
      case(DIR_front): pel = current->down ;break;
      default:
        report;
    }


    if(pel)
    {
      Object*  target = pel->object;

      text::push_to_buffer(u"目の前には　壁がある");

        if(target)
        {
          text::push_to_buffer('\n');
          text::push_to_buffer(u"壁の前には　");
          text::push_to_buffer(target->get_name());
          text::push_to_buffer(u"が立っている");
          text::push_to_buffer('\n');
        }


      sys.text_waiting_flag = true;
    }
}





