#ifndef MOVING_CONTEXT_HPP
#define MOVING_CONTEXT_HPP


#include"util.hpp"
#include"clock.hpp"




enum
Dir
{
  DIR_left ,
  DIR_right,
  DIR_front,
  DIR_back ,
  DIR_up   ,
  DIR_down ,

};


struct
MovingContext
{
  SDL_Point  dst_point;
  SDL_Point      point;

  int  src_x_base;
  int  src_y_base;

  int   width;
  int  height;

  Dir  motion_dir;
  Dir   shape_dir;

  int  motion_type;
  int  motion_phase;
  int  motion_count;
  int  motion_number;

  Clock  clock;

  MovingContext();

};



#endif




