#include"object.hpp"




namespace{


int
compare(const char16_t*  a, const char16_t*  b)
{
     while(*a && *b)
     {
       const int  ac = *a++;
       const int  bc = *b++;

            if(ac < bc){return -1;}
       else if(ac > bc){return  1;}
     }


     if(!*a)
     {
         if(!*b)
         {
           return 0;
         }


       return -1;
     }


  return 1;
}


}




bool
ObjectCompare::
operator()(const Object*  a, const Object*  b)
{
    if(a->object_gid == b->object_gid)
    {
        if(a->object_uid == b->object_uid)
        {
          return(compare(a->get_name(),b->get_name()) < 0);
        }


      return(a->object_uid < b->object_uid);
    }


  return(a->object_gid < b->object_gid);
}




Object::
Object(ObjectGID  gid, ObjectUID  uid, const char16_t*  _name):
object_gid(gid),
object_uid(uid),
name(_name),
group(nullptr),
member_index(MEMB_invalid)
{}


Object::
~Object()
{}




void             Object::set_name(const char16_t*  _name)      {       name = _name;}
const char16_t*  Object::get_name(                      ) const{return name        ;}


void
Object::
set_group(Group*  grp, MemberIndex  i)
{
  group = grp;
  member_index = i;
}


Group*  Object::get_group(){return group;}

MemberIndex  Object::get_member_index() const{return member_index;}


void  Object::update(){}




