#ifndef SHAPE_CONTEXT_HPP
#define SHAPE_CONTEXT_HPP


#include"util.hpp"




struct
ShapeContext
{
  SDL_Texture*  texture;

  SDL_Rect  src_rect;

  SDL_RendererFlip  flip;

  ShapeContext();

  void  set_size(int  w, int  h);

  void    set_hflip();
  void  unset_hflip();

  void    set_vflip();
  void  unset_vflip();

  void  draw(int  x, int  y) const;

};




#endif




