#include"system.hpp"
#include"human.hpp"




namespace{


}




System
sys;


Place
world(0,u"",8,8);


Player
player(u"",nullptr,0,0);




System::
System():
current_place(&world)
{
}




void
System::
draw()
{
  SDL_SetRenderDrawColor(sys.renderer,0,0,0,255);

  SDL_RenderClear(sys.renderer);

  world.draw();

  update_entries();

    for(auto&  v: humans)
    {
        for(auto&  hum: v)
        {
          hum->draw();
        }
    }
}


void
System::
update_entries()
{
    for(auto&  v: humans)
    {
      v.clear();
    }


    for(auto  obj: current_place->human_group.children)
    {
      auto&  hum = *(Human*)obj;

      humans[hum.movctx.dst_point.y/tile_size].emplace_back(&hum);
    }
}




void
System::
lock_streaming()
{
  streaming_flag = false;
}


void
System::
unlock_streaming()
{
  streaming_flag = true;
}





