#include"clock.hpp"




namespace{


uint32_t
now;


}




Clock::
Clock(uint32_t  _delay_time):
delay_time(_delay_time),
last_time(now)
{
}


void
Clock::
update()
{
  now = SDL_GetTicks();
}


void
Clock::
set_delay(uint32_t  v)
{
  delay_time = v;
}


uint32_t
Clock::
get_delay() const
{
  return delay_time;
}


bool
Clock::
operator()()
{
    if(now >= (last_time+delay_time))
    {
      last_time = now;

      return true;
    }


  return false;
}




