#include"shape_context.hpp"
#include"system.hpp"




ShapeContext::
ShapeContext():
texture(nullptr),
flip(SDL_FLIP_NONE)
{
}




void
ShapeContext::
set_size(int  w, int  h)
{
  src_rect.w = w;
  src_rect.h = h;
}




void  ShapeContext::  set_hflip(){flip = (SDL_RendererFlip)(flip| SDL_FLIP_HORIZONTAL);}
void  ShapeContext::unset_hflip(){flip = (SDL_RendererFlip)(flip&~SDL_FLIP_HORIZONTAL);}

void  ShapeContext::  set_vflip(){flip = (SDL_RendererFlip)(flip| SDL_FLIP_VERTICAL);}
void  ShapeContext::unset_vflip(){flip = (SDL_RendererFlip)(flip&~SDL_FLIP_VERTICAL);}


void
ShapeContext::
draw(int  x, int  y) const
{
  SDL_Rect  dst_rect = {x,y,src_rect.w,src_rect.h};

  SDL_RenderCopyEx(sys.renderer,texture,&src_rect,&dst_rect,0,nullptr,flip);
}




