#ifndef TEXT_AREA_HPP
#define TEXT_AREA_HPP


#include"system.hpp"
#include"clock.hpp"


namespace text{


void  push_to_buffer(char16_t  c);
void  push_to_buffer(const char16_t*  s);

void  push_from_buffer();

size_t  get_buffer_remain();

void  newline();

void  push_direct(char16_t  c);
void  push_direct(const char16_t*  s);

extern Clock  clock;

void  draw();

void  clear();

void    set_streaming_flag();
void  unset_streaming_flag();

bool  test_streaming_flag();


}




#endif




